import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
from datetime import datetime

data = pd.read_csv('Datas/Dtree/data_destree.csv', sep=',')

index_def = data['index_def']
ouverture_ch1 = data['Ch1_Ouverture']


printemps = [4, 5, 6]
ete = [7, 8, 9]
automne = [10, 11, 12]
hiver = [1, 2, 3]

# --------- Ouverture Chambre 1 ------------
heure_printemps = np.zeros(24)
heure_ete = np.zeros(24)
heure_automne = np.zeros(24)
heure_hiver = np.zeros(24)


for k in range(len(index_def)):
    if int(ouverture_ch1[k]) != 0:
        time = pd.to_datetime(index_def[k], format='%Y-%m-%dT%H:%M:%S')
        if int(time.month) in printemps:
            heure_printemps[int(time.hour)] += ouverture_ch1[k]
        if int(time.month) in ete:
            heure_ete[int(time.hour)] += ouverture_ch1[k]
        if int(time.month) in automne:
            heure_automne[int(time.hour)] += ouverture_ch1[k]
        if int(time.month) in hiver:
            heure_hiver[int(time.hour)] += ouverture_ch1[k]


plt.figure()
plt.plot(range(24), heure_ete, label='été')
plt.plot(range(24), heure_hiver, label='hiver')
plt.plot(range(24), heure_automne, label='automne')
plt.plot(range(24), heure_printemps, label='printemps')
plt.xlabel('heures de la journée')
plt.ylabel("nombre d'ouverture de la fenêtre ")
plt.title("Ouvertures de la fenêtre de la chambre 1 suivant les saisons")
plt.legend()


# --------- Ouverture Cuisine ------------
ouverture_rdc = data['RDC_Ouverture']

heure_printemps_RDC = np.zeros(24)
heure_ete_RDC = np.zeros(24)
heure_automne_RDC = np.zeros(24)
heure_hiver_RDC = np.zeros(24)


for k in range(len(index_def)):
    if int(ouverture_rdc[k]) != 0:
        time = pd.to_datetime(index_def[k], format='%Y-%m-%dT%H:%M:%S')
        if int(time.month) in printemps:
            heure_printemps_RDC[int(time.hour)] += ouverture_rdc[k]
        if int(time.month) in ete:
            heure_ete_RDC[int(time.hour)] += ouverture_rdc[k]
        if int(time.month) in automne:
            heure_automne_RDC[int(time.hour)] += ouverture_rdc[k]
        if int(time.month) in hiver:
            heure_hiver_RDC[int(time.hour)] += ouverture_rdc[k]

plt.figure()
plt.plot(range(24), heure_ete_RDC, label='été')
plt.plot(range(24), heure_hiver_RDC, label='hiver')
plt.plot(range(24), heure_automne_RDC, label='automne')
plt.plot(range(24), heure_printemps_RDC, label='printemps')
plt.xlabel('heures de la journée')
plt.ylabel("nombre d'ouverture de la fenêtre ")
plt.title("Ouvertures de la fenêtre de la cuisine suivant les saisons")
plt.legend()
plt.show()



