from http.server import BaseHTTPRequestHandler, HTTPServer
import urllib
import time
from influxdb import InfluxDBClient
import sys
import csv
import pandas as pd
import matplotlib.pyplot as plt
import time
from datetime import datetime

###########################
#    SCRIPT SETTINGS
###########################
# Set the port where you want the bridge service to run
PORT_NUMBER = 1234
# InfluxDB Server parameters
INFLUXDB_SERVER_IP = '82.65.155.71'
INFLUXDB_SERVER_PORT = 8086
INFLUXDB_USERNAME = 'eleves'
INFLUXDB_PASSWORD = 'SmarthouseG2Elab'
INFLUXDB_DB_NAME = 'jeedom'
###########################

client = InfluxDBClient(INFLUXDB_SERVER_IP, INFLUXDB_SERVER_PORT, INFLUXDB_USERNAME, INFLUXDB_PASSWORD,
                        INFLUXDB_DB_NAME, ssl=True, verify_ssl=False)

print(client.get_list_database())

client.switch_database('jeedom')


# ATTENTION : il FAUT commencer par regarder les séries de données d'ouverture de fenetre pour le bon fonctionnement
# du code
identifiant = [4291, 4296, 885, 3887, 3888, 3889, 3892, 3894, 3897, 3911, 3914, 3915, 3917, 3918, 5484]
names = ['Ch2_Ouverture', 'Ch1_Ouverture', 'RDC_Ouverture', 'RDC_CO2', 'RDC_Bruit', 'RDC_Temperature', 'RDC_Humidite',
         'Exterieur_Temperature', 'Exterieur_Humidite'
         , 'Ch2_Temperature', 'Ch2_Humidite', 'Ch2_CO2', 'Ch1_Temperature', 'Ch1_Humidite', 'bbxco2_ch1']



# fonction qui enlève les caractères après le temps dans la colonne time du dataframe'''
def date_str_to_datetime(datetime_str):
    if "." in datetime_str:  # par exemple : 2022-01-30T14:21:20.435423Z --> 2022-01-30T14:21:20
        datetime_str = datetime_str.split(".")[0]  # on prend uniquement la chaine de caractère avant le point
    else:
        datetime_str = datetime_str.split("Z")[0]  # par exemple : 2022-01-30T14:21:20Z --> 2022-01-30T14:21:20
    return datetime.fromtimestamp(time.mktime(time.strptime(datetime_str, '%Y-%m-%dT%H:%M:%S')))


# Initialisation
df_final = pd.DataFrame()  # création du nouvel dataframe qui nous permettra de le mettre dans un CVS final
liste_pas_bon = []


min_longueur = 0
for n in identifiant:
    name = str(names[identifiant.index(n)])
    print("ind : ", n, " name : ", name)

    # Extraction des données du site
    datasheet = client.query(f'SELECT "value" FROM "jeedom"."autogen"."' + str(n) + '" WHERE time > now() - 365d')

    exported_data = list(datasheet.get_points())
    header_list = list(exported_data[0].keys())
 '''
    # Ecriture des données dans différents csv
    with open("Datas/RAW/dataraw" + str(n) + ".csv", "w", newline='') as fp:
        writer = csv.writer(fp, dialect='excel')
        #  print(header_list[1:])
        value_header = header_list[1]
        offset = sum(c.isalpha() for c in value_header)
        # print(offset)
        # header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
        header_list[1:] = ['value']
        writer.writerow(header_list)
        for line in exported_data:
            writer.writerow([line[kn] for kn in header_list])
'''
    # Mise en forme des fichiers :
    data = pd.read_csv("Datas/RAW/dataraw" + str(n) + ".csv", sep=',')
    data['time'] = data['time'].apply(date_str_to_datetime)
    data['time'] = pd.to_datetime(data['time'], format='%Y-%m-%dT%H:%M:%S')
    data = data.drop_duplicates()  # supprime les lignes où le datetime est le même
    data.rename(columns={'value': name}, inplace=True)  # on change le nom de de la colonne

    # *** les fichiers d'ouverture de fenetre ne prennent pas en compte le dernier jour et ne sont donc pas sur le même
    # nombre d'heures que les autres. Il faudra donc couper les autres séries pour qu'ils soient de la même taille que
    # les fichiers ouvertures afin de pourvoir les comparer

    # Resample des données sur une heure :
    if n in [4291, 4296, 885]:
        data = data.resample('60T', on='time').sum()  # somme sur les ouvertures
    else:
        data = data.resample('60T', on='time').mean()  # moyenne avec les autres series

    data.to_csv(f"Datas/RAW/dataraw{n}_resample.csv", sep=',')  # crée des nouveaux fichiers CVS avec les bonnes données


    # Ajout dans un fichier csv commun :
    if len(data) == 8761:
        L = []
        index_def = data.index
        for i in range(len(data)):
            L.append(data[name][i])

        df_final['index_def'] = index_def
        df_final[name] = L

    else:
        liste_pas_bon.append([name, len(data)])



df_final.set_index("index_def")
df_final.to_csv("Datas/RAW/dataraw.csv", sep=',')  # crée des nouveaux fichiers CVS avec les bonnes données
print(liste_pas_bon)




# ''' fais une liste des heures de l'année pour les mettre en index'''
# mtn = datetime.now()
# mtn = datetime(mtn.year, mtn.month, mtn.day, mtn.hour, 0, 0)
# temps = [mtn]
# for i in range(365*24-1):
#     mtn += datetime.timedelta(hours=-1)
#     temps.append(mtn)
# temps = [k.strftime('%Y-%m-%d %H:%M:%S') for k in temps]
# temps_ordre = []
# for k in range(len(temps)):
#     temps_ordre.append(temps[len(temps) - k - 1])
